using System;
using System.Collections.Generic;
using System.Text;
using Ultimarc;
//using GroovyGameGear;
using ICSharpCode.USBlib;

namespace setControls
{
    class Program
    {
        static void Main(string[] args)
        {
            bool success;

            if (args.Length == 0)
            {
                Console.WriteLine("Enter a Programming Mode");
            }
            else if (args[0] == "debug")
            {

                if (Environment.OSVersion.Platform == PlatformID.Unix)
                {
                    Console.WriteLine("Running on UNIX");
                    Console.WriteLine();
                }
                else
                {
                    Console.WriteLine("Running on " + Environment.OSVersion.VersionString);
                    Console.WriteLine();
                }

                try
                {
                    foreach (Bus bus in Bus.Busses)
                    {
                        
                        foreach (Descriptor descriptor in bus.Descriptors)
                        {

                            using (Device device = descriptor.OpenDevice())
                            {
                                    Console.WriteLine("\t\t     Product: " + device.Product);
                                    Console.WriteLine("\t\tManufacturer: " + device.Manufacturer);
                                    Console.WriteLine("\t\t      Serial: " + device.SerialNumber);
                                    Console.WriteLine("\t\t   bcdDevice: 0x" + Convert.ToString(device.Descriptor.bcdDevice,16).PadLeft(4,'0'));
                                    Console.WriteLine("\t\t         VID: 0x" + Convert.ToString(device.Descriptor.VendorId, 16).PadLeft(4, '0').ToUpper());
                                    Console.WriteLine("\t\t         PID: 0x" + Convert.ToString(device.Descriptor.ProductId, 16).PadLeft(4, '0').ToUpper());
                                    Console.WriteLine();
                            }
                        }
                    }
                }
                catch (UsbException e)
                {
                    Console.WriteLine("Got Exception : " + e);
                }
            }
            else if (args[0].EndsWith(".um"))
            {
                Ultimarc.Ultrastik[] ultrastikArray = Ultimarc.Ultrastik.Open();

                if (ultrastikArray.Length > 0)
                {
                    Array.Sort(ultrastikArray);
                    Console.WriteLine("Programming Map: " + args[0]);
                    for (int counter = 0; (counter < ultrastikArray.Length); counter++)
                    {
                        ultrastikArray[counter].Restrictor = true;
                        ultrastikArray[counter].UseFlash = false;
                        success = ultrastikArray[counter].LoadMapFile(args[0]);
                        if (success)
                            Console.WriteLine("Finished Programming " + ultrastikArray[counter].Product);
                        else
                            Console.WriteLine("Failed to Program " + ultrastikArray[counter].Product);
                    }
                }
                else
                {
                    Console.WriteLine("No Devices found");
                }
            }
            else
            {
                Ultimarc.Ultrastik[] ultrastikArray = Ultimarc.Ultrastik.Open();

                if (ultrastikArray.Length > 0)
                {
                    Array.Sort(ultrastikArray);
                    Console.WriteLine("Programming Mode: " + args[0]);
                    for (int counter = 0; (counter < ultrastikArray.Length); counter++)
                    {
                        ultrastikArray[counter].Restrictor = true;
                        ultrastikArray[counter].UseFlash = false;
                        success = ultrastikArray[counter].LoadMap(args[0]);
                        if (success)
                            Console.WriteLine("Finished Programming " + ultrastikArray[counter].Product);
                        else
                            Console.WriteLine("Failed to Program " + ultrastikArray[counter].Product);
                    }
                }
                else
                {
                    Console.WriteLine("No Devices found");
                }
            }
            
        }
    }
}
